<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIPregelGraphLibrary: src/standard/modules/data_structures/pregel/PregelAggregate.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIPregelGraphLibrary
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_3a3fb334f8e32f8b75f30f6eb3cfdf6e.html">src</a></li><li class="navelem"><a class="el" href="dir_41b3ccb19a6d365afc2b4a7bbd034095.html">standard</a></li><li class="navelem"><a class="el" href="dir_e5e605185631aa34c675c5c984a4ce63.html">modules</a></li><li class="navelem"><a class="el" href="dir_65dbd4b4a905925d7fdc0769c790cfff.html">data_structures</a></li><li class="navelem"><a class="el" href="dir_898d09fa8680f6b1e8ac927c9d8807ef.html">pregel</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">PregelAggregate.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="PregelAggregate_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#ifndef PREGELAGGREGATE_HPP_</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#define PREGELAGGREGATE_HPP_</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">/****************************************************************************************************************/</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">/****************************************************************************************************************/</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">/****************************************************************************************************************/</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &quot;omp_tools.h&quot;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &quot;pregel_macros.h&quot;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> AlgData&gt;</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classAggregateSysMessage.html">   35</a></span>&#160;<span class="keyword">class </span><a class="code" href="classAggregateSysMessage.html">TIGLCommunicationAggregateSysMessage</a></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;{</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="comment">// maximum aggregate value</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    AlgData maxAgg;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="comment">//minimum aggregate value</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    AlgData minAgg;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="comment">// sum of aggregate values</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    AlgData sumAgg;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="classAggregateSysMessage.html#ae919541ce5708fd7806568b53242192b">   47</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAggregateSysMessage.html#ae919541ce5708fd7806568b53242192b">setMax</a>(AlgData val) {maxAgg = val;}</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="classAggregateSysMessage.html#a5139f89e6e3de91aadb6c1d7d00d5b85">   50</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAggregateSysMessage.html#a5139f89e6e3de91aadb6c1d7d00d5b85">setMin</a>(AlgData val) {minAgg = val;}</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classAggregateSysMessage.html#abd76b49854b26b0578122c6856439c8e">   53</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAggregateSysMessage.html#abd76b49854b26b0578122c6856439c8e">setSum</a>(AlgData val) {sumAgg = val;}</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="classAggregateSysMessage.html#a8e08c4bb1f8d6b7a4c50111564c81b91">   57</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> AlgData <a class="code" href="classAggregateSysMessage.html#a8e08c4bb1f8d6b7a4c50111564c81b91">getMax</a>() {<span class="keywordflow">return</span> maxAgg ;}</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classAggregateSysMessage.html#a8e924b18478632256b8169c7745708a2">   60</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> AlgData <a class="code" href="classAggregateSysMessage.html#a8e924b18478632256b8169c7745708a2">getMin</a>() {<span class="keywordflow">return</span> minAgg ;}</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="classAggregateSysMessage.html#a4d57d5b780c49f6b2d1fc8bd3bc33458">   63</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> AlgData <a class="code" href="classAggregateSysMessage.html#a4d57d5b780c49f6b2d1fc8bd3bc33458">getSum</a>() {<span class="keywordflow">return</span> sumAgg;}</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;};</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> AlgData&gt;</div>
<div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="classAggInfo.html">   80</a></span>&#160;<span class="keyword">class </span><a class="code" href="classAggInfo.html">TIGLContainersAggregate</a></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;{</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keyword">typedef</span> AlgData                                 ALG_DATA_TYPE;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keyword">typedef</span> <a class="code" href="classAggregateSysMessage.html">TIGLCommunicationAggregateSysMessage&lt;AlgData&gt;</a>    <a class="code" href="classAggregateSysMessage.html">AGG_SYS_MESSAGE_TYPE</a>;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="comment">// constructor/destructor</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <a class="code" href="classAggInfo.html">TIGLContainersAggregate</a>()</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    {</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="preprocessor">#if defined(_OPENMP)</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        omp_init_lock(&amp;aggLock);</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    }</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    ~<a class="code" href="classAggInfo.html">TIGLContainersAggregate</a>()</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    {</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="preprocessor">#if defined(_OPENMP)</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        omp_destroy_lock(&amp;aggLock);</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    }</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="comment">// static info</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="comment">//total number of vertices in the graph</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    uint32 numVertices;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="comment">//number of local vertices for this device</span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    uint32 numLocalVertices;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="comment">// runtime statistics/info</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="comment">//superstep counter</span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    uint32 countSS;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="comment">//total number of output messages over a superstep history</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    uint32 numTotalMessages[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="comment">//total number of external output messages over a superstep history</span></div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    uint32 numExternalMessages[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="comment">//number of local active nodes over a superstep history</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    uint32 numLocalActiveNodes[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="comment">//total number of active nodes over a superstep history</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    uint32 numTotalActiveNodes[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="comment">// algorithm specific information</span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="comment">//maximum value of algorithm data of all active vertices over a superstep history</span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    AlgData maxActiveAlgData[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    <span class="comment">//minimum value of algorithm data of all active vertices over a superstep history</span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    AlgData minActiveAlgData[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="comment">//the sum of the values of algorithm data of all active vertices over a superstep history</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    AlgData sumActiveAlgData[AGGREGATE_HISTORY];</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keywordtype">bool</span> isUpdated;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    <span class="comment">// openMP lock for updating aggregate info</span></div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="preprocessor">#if defined(_OPENMP)</span></div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    omp_lock_t aggLock;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00143"></a><span class="lineno"><a class="line" href="classAggInfo.html#ab8b1cb035fc7f03e489f0510cbc7fc05">  143</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAggInfo.html#ab8b1cb035fc7f03e489f0510cbc7fc05">localAggregateInit</a>(uint32 ssIndex, uint32 numLocActiveNodes)</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    {</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        countSS = ssIndex;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="keywordtype">int</span> t =  countSS%AGGREGATE_HISTORY;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        numTotalMessages[t]     = 0;</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        numExternalMessages[t] = 0;</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        numLocalActiveNodes[t] = numLocActiveNodes;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        isUpdated = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    }</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;<span class="comment"></span>    <span class="comment">//@param currNumMessages the output number of messages after vertex execution</span></div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> VERTEX_ITERATOR&gt;</div>
<div class="line"><a name="l00160"></a><span class="lineno"><a class="line" href="classAggInfo.html#a71f8ccb076be729b46722dd1ab9524a8">  160</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classAggInfo.html#a71f8ccb076be729b46722dd1ab9524a8">localAggregateUpdate</a>(VERTEX_ITERATOR vertexIt, uint32 currNumMessages)</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    {</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        <span class="keywordtype">int</span> t = countSS%AGGREGATE_HISTORY;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <span class="keywordflow">if</span>(vertexIt-&gt;isActive())</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        {</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;            <span class="comment">//lock();</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            ALG_DATA_TYPE newData = vertexIt-&gt;getAlgData();</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;            <span class="keywordflow">if</span>(maxActiveAlgData[t] &lt; newData || isUpdated == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;            {</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;                OMP(<span class="stringliteral">&quot;omp critical (AGGREGATE_MAX)&quot;</span>)</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;                {</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;                    <span class="keywordflow">if</span>(maxActiveAlgData[t] &lt; newData)</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;                    {</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;                        maxActiveAlgData[t] = newData;</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="comment">//                      ALG_DATA_TYPE * p = &amp;minActiveAlgData[t];</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="comment">//                      OMP(&quot;omp flush (p)&quot;)</span></div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;                    }</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;                }</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;            }</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;            <span class="keywordflow">if</span>(minActiveAlgData[t] &gt; newData || isUpdated == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;            {</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;                OMP(<span class="stringliteral">&quot;omp critical(AGGREGATE_MIN)&quot;</span>)</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;                {</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;                    <span class="keywordflow">if</span>(minActiveAlgData[t] &gt; newData)</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;                    {</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;                        minActiveAlgData[t] = newData;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;<span class="comment">//                      ALG_DATA_TYPE * p = &amp;minActiveAlgData[t];</span></div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="comment">//                      OMP(&quot;omp flush (p)&quot;)</span></div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;                    }</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;                }</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            }</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            OMP(<span class="stringliteral">&quot;omp critical(AGGREGATE_SUM)&quot;</span>)</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;            {</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;                <span class="keywordflow">if</span>(isUpdated == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;                    sumActiveAlgData[t] += newData;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;                <span class="keywordflow">else</span></div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;                    sumActiveAlgData[t] = newData;</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;            }</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        }</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="comment">//lock();</span></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        OMP(<span class="stringliteral">&quot;omp atomic&quot;</span>)</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        numTotalMessages[t] += currNumMessages;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        <span class="comment">//unlock();</span></div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        <span class="keywordflow">if</span>(isUpdated == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        {</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;            isUpdated = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;            OMP(<span class="stringliteral">&quot;omp flush(isUpdated)&quot;</span>)</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        }</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    }</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00214"></a><span class="lineno"><a class="line" href="classAggInfo.html#a8053ab15460a14476c7a71371b1d2d6d">  214</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">void</span> <a class="code" href="classAggInfo.html#a8053ab15460a14476c7a71371b1d2d6d">externalAggregateUpdate</a>(<a class="code" href="classAggregateSysMessage.html">AGG_SYS_MESSAGE_TYPE</a> * aggSysInfo)</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    {</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        <span class="keywordtype">int</span> t = (countSS-1)%AGGREGATE_HISTORY;</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        ALG_DATA_TYPE newData = aggSysInfo-&gt;<a class="code" href="classAggregateSysMessage.html#a8e08c4bb1f8d6b7a4c50111564c81b91">getMax</a>();</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        <span class="keywordflow">if</span>(maxActiveAlgData[t] &lt; newData)</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        {</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;            maxActiveAlgData[t] = newData;</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        }</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        newData = aggSysInfo-&gt;<a class="code" href="classAggregateSysMessage.html#a8e924b18478632256b8169c7745708a2">getMin</a>();</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        <span class="keywordflow">if</span>(minActiveAlgData[t] &gt; newData)</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        {</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;            minActiveAlgData[t] = newData;</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        }</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        newData = aggSysInfo-&gt;<a class="code" href="classAggregateSysMessage.html#a4d57d5b780c49f6b2d1fc8bd3bc33458">getSum</a>();</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        sumActiveAlgData[t] += newData;</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    }</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;<span class="comment"></span>    <span class="comment">//@param aggSysInfo pointer to the received external message</span></div>
<div class="line"><a name="l00234"></a><span class="lineno"><a class="line" href="classAggInfo.html#aadbf3019d3dfe78da479e1e69befc203">  234</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classAggInfo.html#aadbf3019d3dfe78da479e1e69befc203">prepareAggregateSysMessage</a>(<a class="code" href="classAggregateSysMessage.html">AGG_SYS_MESSAGE_TYPE</a> * aggSysInfo)</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    {</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        <span class="keywordtype">int</span> t = countSS%AGGREGATE_HISTORY;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        aggSysInfo-&gt;<a class="code" href="classAggregateSysMessage.html#ae919541ce5708fd7806568b53242192b">setMax</a>(maxActiveAlgData[t]);</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        aggSysInfo-&gt;<a class="code" href="classAggregateSysMessage.html#a5139f89e6e3de91aadb6c1d7d00d5b85">setMin</a>(minActiveAlgData[t]);</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        aggSysInfo-&gt;<a class="code" href="classAggregateSysMessage.html#abd76b49854b26b0578122c6856439c8e">setSum</a>(sumActiveAlgData[t]);</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="comment">//      cout &lt;&lt; &quot;countSS &quot; &lt;&lt; countSS &lt;&lt; &quot;: max &quot;&lt;&lt; maxActiveAlgData[t] &lt;&lt; endl;</span></div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    }</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00246"></a><span class="lineno"><a class="line" href="classAggInfo.html#ab3b13064337d382555b097d41085231f">  246</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAggInfo.html#ab3b13064337d382555b097d41085231f">incrementExternalMessagesCount</a>(uint32 currNumMessages)</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    {</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        lock();</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        numExternalMessages[countSS%AGGREGATE_HISTORY] += currNumMessages;</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        unlock();</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    }</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00256"></a><span class="lineno"><a class="line" href="classAggInfo.html#ab5d50b70e31980555b9b2e2ed3b8cb19">  256</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classAggInfo.html#ab5d50b70e31980555b9b2e2ed3b8cb19">setNumLocalActiveNoes</a>(uint32 numActive)</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;    {</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        numLocalActiveNodes[countSS%AGGREGATE_HISTORY] = numActive;</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;    }</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00263"></a><span class="lineno"><a class="line" href="classAggInfo.html#a1d24147dfa3739d01f9b21e6a98fafc9">  263</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classAggInfo.html#a1d24147dfa3739d01f9b21e6a98fafc9">getNumExternalMessages</a>(){<span class="keywordflow">return</span> numExternalMessages[countSS%AGGREGATE_HISTORY];}</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00267"></a><span class="lineno"><a class="line" href="classAggInfo.html#ad84b8ce83c73398deec9b880e53a2863">  267</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classAggInfo.html#ad84b8ce83c73398deec9b880e53a2863">getPastNumExternalMessages</a>(){<span class="keywordflow">return</span> numExternalMessages[(countSS-1)%AGGREGATE_HISTORY];}</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00270"></a><span class="lineno"><a class="line" href="classAggInfo.html#a5f5b8af459c280fbb50955f763a4c00c">  270</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classAggInfo.html#a5f5b8af459c280fbb50955f763a4c00c">getNumTotalMessages</a>(){<span class="keywordflow">return</span> numTotalMessages[countSS%AGGREGATE_HISTORY];}</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00273"></a><span class="lineno"><a class="line" href="classAggInfo.html#adb09db15922ba0dc90b8e0aae0e93bfc">  273</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classAggInfo.html#adb09db15922ba0dc90b8e0aae0e93bfc">getPastNumTotalMessages</a>(){<span class="keywordflow">return</span> numTotalMessages[(countSS-1)%AGGREGATE_HISTORY];}</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    <span class="comment">// static info</span></div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00277"></a><span class="lineno"><a class="line" href="classAggInfo.html#a902ee9574bb43a165170566e622621ad">  277</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classAggInfo.html#a902ee9574bb43a165170566e622621ad">getNumVertices</a>(){<span class="keywordflow">return</span> numVertices;}</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00280"></a><span class="lineno"><a class="line" href="classAggInfo.html#a0907940a858eba1da671bd44dfad98d3">  280</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span>  <a class="code" href="classAggInfo.html#a0907940a858eba1da671bd44dfad98d3">setNumVertices</a>(uint32 num){numVertices = num;}</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00283"></a><span class="lineno"><a class="line" href="classAggInfo.html#a1a4e57cb326a1042f463724f3fb6495a">  283</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classAggInfo.html#a1a4e57cb326a1042f463724f3fb6495a">getNumLocalVertices</a>(){<span class="keywordflow">return</span> numLocalVertices;}</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00286"></a><span class="lineno"><a class="line" href="classAggInfo.html#aa652345547c72a9e49d2cc097ed824e1">  286</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span>  <a class="code" href="classAggInfo.html#aa652345547c72a9e49d2cc097ed824e1">setNumLocalVertices</a>(uint32 num){numLocalVertices = num;}</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    <span class="comment">// runtime statistics/info</span></div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    <span class="keyword">inline</span> uint32 getNumSS(){<span class="keywordflow">return</span> countSS;}</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    <span class="comment">// algorithm specific information</span></div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00296"></a><span class="lineno"><a class="line" href="classAggInfo.html#a6129464657e507c1215f3e1e6702081d">  296</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span>  AlgData &amp; <a class="code" href="classAggInfo.html#a6129464657e507c1215f3e1e6702081d">getMaxActiveAlgData</a>(){<span class="keywordflow">return</span> maxActiveAlgData[countSS%AGGREGATE_HISTORY];}</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00299"></a><span class="lineno"><a class="line" href="classAggInfo.html#ad3d20ae3cc002791fdaca8fb656b477a">  299</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span>  AlgData &amp; <a class="code" href="classAggInfo.html#ad3d20ae3cc002791fdaca8fb656b477a">getPastMaxActiveAlgData</a>(){<span class="keywordflow">return</span> maxActiveAlgData[(countSS-1)%AGGREGATE_HISTORY];}</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00302"></a><span class="lineno"><a class="line" href="classAggInfo.html#a9976289825d64ffc1702eee9d58ae28e">  302</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span>  AlgData &amp; <a class="code" href="classAggInfo.html#a9976289825d64ffc1702eee9d58ae28e">getMinActiveAlgData</a>(){<span class="keywordflow">return</span> minActiveAlgData[countSS%AGGREGATE_HISTORY];}</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00305"></a><span class="lineno"><a class="line" href="classAggInfo.html#a2575c2c465e71141d2cbd9631b9080c6">  305</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span>  AlgData &amp; <a class="code" href="classAggInfo.html#a2575c2c465e71141d2cbd9631b9080c6">getPastMinActiveAlgData</a>(){<span class="keywordflow">return</span> minActiveAlgData[(countSS-1)%AGGREGATE_HISTORY];}</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00309"></a><span class="lineno"><a class="line" href="classAggInfo.html#a55085f6099a4c84bdbe0c9c57df7758d">  309</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span>  AlgData &amp; <a class="code" href="classAggInfo.html#a55085f6099a4c84bdbe0c9c57df7758d">getSumActiveAlgData</a>(){<span class="keywordflow">return</span> sumActiveAlgData[countSS%AGGREGATE_HISTORY];}</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00312"></a><span class="lineno"><a class="line" href="classAggInfo.html#a1c6117841204067e5fa705d3b9696e69">  312</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span>  AlgData &amp; <a class="code" href="classAggInfo.html#a1c6117841204067e5fa705d3b9696e69">getPastSumActiveAlgData</a>(){<span class="keywordflow">return</span> sumActiveAlgData[(countSS-1)%AGGREGATE_HISTORY];}</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    <span class="comment">//=====================================================================================================================</span></div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;<span class="preprocessor">#if defined(_OPENMP)</span></div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> lock(){ omp_set_lock(&amp;aggLock);}</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> unlock(){omp_unset_lock(&amp;aggLock);}</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> lock(){}</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> unlock(){}</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;};</div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* PREGELAGGREGATECLASS_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classAggregateSysMessage_html_a8e08c4bb1f8d6b7a4c50111564c81b91"><div class="ttname"><a href="classAggregateSysMessage.html#a8e08c4bb1f8d6b7a4c50111564c81b91">TIGLCommunicationAggregateSysMessage::getMax</a></div><div class="ttdeci">AlgData getMax()</div><div class="ttdoc">get the max value field </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:57</div></div>
<div class="ttc" id="classAggInfo_html_a1c6117841204067e5fa705d3b9696e69"><div class="ttname"><a href="classAggInfo.html#a1c6117841204067e5fa705d3b9696e69">TIGLContainersAggregate::getPastSumActiveAlgData</a></div><div class="ttdeci">AlgData &amp; getPastSumActiveAlgData()</div><div class="ttdoc">returns the sum of the algorithm data of all active nodes for the previous superstep ...</div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:312</div></div>
<div class="ttc" id="classAggInfo_html_ab5d50b70e31980555b9b2e2ed3b8cb19"><div class="ttname"><a href="classAggInfo.html#ab5d50b70e31980555b9b2e2ed3b8cb19">TIGLContainersAggregate::setNumLocalActiveNoes</a></div><div class="ttdeci">void setNumLocalActiveNoes(uint32 numActive)</div><div class="ttdoc">set the number of local active nodes at the end of a superstep </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:256</div></div>
<div class="ttc" id="classAggregateSysMessage_html"><div class="ttname"><a href="classAggregateSysMessage.html">TIGLCommunicationAggregateSysMessage</a></div><div class="ttdoc">base class for aggregate information messages it holds aggregate information that is exchanged betwee...</div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:35</div></div>
<div class="ttc" id="classAggInfo_html_a9976289825d64ffc1702eee9d58ae28e"><div class="ttname"><a href="classAggInfo.html#a9976289825d64ffc1702eee9d58ae28e">TIGLContainersAggregate::getMinActiveAlgData</a></div><div class="ttdeci">AlgData &amp; getMinActiveAlgData()</div><div class="ttdoc">returns the minimum value of the algorithm data of all active nodes for the current superstep ...</div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:302</div></div>
<div class="ttc" id="classAggInfo_html_ab8b1cb035fc7f03e489f0510cbc7fc05"><div class="ttname"><a href="classAggInfo.html#ab8b1cb035fc7f03e489f0510cbc7fc05">TIGLContainersAggregate::localAggregateInit</a></div><div class="ttdeci">void localAggregateInit(uint32 ssIndex, uint32 numLocActiveNodes)</div><div class="ttdoc">reseting the aggregate parameters before the new superstep </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:143</div></div>
<div class="ttc" id="classAggInfo_html_aa652345547c72a9e49d2cc097ed824e1"><div class="ttname"><a href="classAggInfo.html#aa652345547c72a9e49d2cc097ed824e1">TIGLContainersAggregate::setNumLocalVertices</a></div><div class="ttdeci">void setNumLocalVertices(uint32 num)</div><div class="ttdoc">sets the number of local vertices </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:286</div></div>
<div class="ttc" id="classAggregateSysMessage_html_a4d57d5b780c49f6b2d1fc8bd3bc33458"><div class="ttname"><a href="classAggregateSysMessage.html#a4d57d5b780c49f6b2d1fc8bd3bc33458">TIGLCommunicationAggregateSysMessage::getSum</a></div><div class="ttdeci">AlgData getSum()</div><div class="ttdoc">get the sum value field </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:63</div></div>
<div class="ttc" id="classAggInfo_html_a1a4e57cb326a1042f463724f3fb6495a"><div class="ttname"><a href="classAggInfo.html#a1a4e57cb326a1042f463724f3fb6495a">TIGLContainersAggregate::getNumLocalVertices</a></div><div class="ttdeci">uint32 getNumLocalVertices()</div><div class="ttdoc">retruns the number of local vertices </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:283</div></div>
<div class="ttc" id="classAggInfo_html_adb09db15922ba0dc90b8e0aae0e93bfc"><div class="ttname"><a href="classAggInfo.html#adb09db15922ba0dc90b8e0aae0e93bfc">TIGLContainersAggregate::getPastNumTotalMessages</a></div><div class="ttdeci">uint32 getPastNumTotalMessages()</div><div class="ttdoc">returns the total number of output messages of the device in the previous superstep ...</div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:273</div></div>
<div class="ttc" id="classAggInfo_html_a0907940a858eba1da671bd44dfad98d3"><div class="ttname"><a href="classAggInfo.html#a0907940a858eba1da671bd44dfad98d3">TIGLContainersAggregate::setNumVertices</a></div><div class="ttdeci">void setNumVertices(uint32 num)</div><div class="ttdoc">sets the total number of vertices in the whole graph </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:280</div></div>
<div class="ttc" id="classAggInfo_html_a6129464657e507c1215f3e1e6702081d"><div class="ttname"><a href="classAggInfo.html#a6129464657e507c1215f3e1e6702081d">TIGLContainersAggregate::getMaxActiveAlgData</a></div><div class="ttdeci">AlgData &amp; getMaxActiveAlgData()</div><div class="ttdoc">returns the maximum value of the algorithm data of all active nodes for the current superstep ...</div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:296</div></div>
<div class="ttc" id="classAggInfo_html_a2575c2c465e71141d2cbd9631b9080c6"><div class="ttname"><a href="classAggInfo.html#a2575c2c465e71141d2cbd9631b9080c6">TIGLContainersAggregate::getPastMinActiveAlgData</a></div><div class="ttdeci">AlgData &amp; getPastMinActiveAlgData()</div><div class="ttdoc">returns the minimum value of the algorithm data of all active nodes for the previous superstep ...</div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:305</div></div>
<div class="ttc" id="classAggregateSysMessage_html_a8e924b18478632256b8169c7745708a2"><div class="ttname"><a href="classAggregateSysMessage.html#a8e924b18478632256b8169c7745708a2">TIGLCommunicationAggregateSysMessage::getMin</a></div><div class="ttdeci">AlgData getMin()</div><div class="ttdoc">get the min value field </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:60</div></div>
<div class="ttc" id="classAggregateSysMessage_html_abd76b49854b26b0578122c6856439c8e"><div class="ttname"><a href="classAggregateSysMessage.html#abd76b49854b26b0578122c6856439c8e">TIGLCommunicationAggregateSysMessage::setSum</a></div><div class="ttdeci">void setSum(AlgData val)</div><div class="ttdoc">set the sum value field </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:53</div></div>
<div class="ttc" id="classAggInfo_html_a8053ab15460a14476c7a71371b1d2d6d"><div class="ttname"><a href="classAggInfo.html#a8053ab15460a14476c7a71371b1d2d6d">TIGLContainersAggregate::externalAggregateUpdate</a></div><div class="ttdeci">void externalAggregateUpdate(AGG_SYS_MESSAGE_TYPE *aggSysInfo)</div><div class="ttdoc">updating the aggregate information after receiving an update from other devices </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:214</div></div>
<div class="ttc" id="classAggInfo_html_a1d24147dfa3739d01f9b21e6a98fafc9"><div class="ttname"><a href="classAggInfo.html#a1d24147dfa3739d01f9b21e6a98fafc9">TIGLContainersAggregate::getNumExternalMessages</a></div><div class="ttdeci">uint32 getNumExternalMessages()</div><div class="ttdoc">returns the number of external messages in the current superstep </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:263</div></div>
<div class="ttc" id="classAggInfo_html_a5f5b8af459c280fbb50955f763a4c00c"><div class="ttname"><a href="classAggInfo.html#a5f5b8af459c280fbb50955f763a4c00c">TIGLContainersAggregate::getNumTotalMessages</a></div><div class="ttdeci">uint32 getNumTotalMessages()</div><div class="ttdoc">returns the total number of output messages of the device in the current superstep ...</div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:270</div></div>
<div class="ttc" id="classAggInfo_html_ad3d20ae3cc002791fdaca8fb656b477a"><div class="ttname"><a href="classAggInfo.html#ad3d20ae3cc002791fdaca8fb656b477a">TIGLContainersAggregate::getPastMaxActiveAlgData</a></div><div class="ttdeci">AlgData &amp; getPastMaxActiveAlgData()</div><div class="ttdoc">returns the maximum value of the algorithm data of all active nodes for the previous superstep ...</div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:299</div></div>
<div class="ttc" id="classAggInfo_html_a55085f6099a4c84bdbe0c9c57df7758d"><div class="ttname"><a href="classAggInfo.html#a55085f6099a4c84bdbe0c9c57df7758d">TIGLContainersAggregate::getSumActiveAlgData</a></div><div class="ttdeci">AlgData &amp; getSumActiveAlgData()</div><div class="ttdoc">returns the sum of the algorithm data of all active nodes for the current superstep ...</div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:309</div></div>
<div class="ttc" id="classAggInfo_html_ad84b8ce83c73398deec9b880e53a2863"><div class="ttname"><a href="classAggInfo.html#ad84b8ce83c73398deec9b880e53a2863">TIGLContainersAggregate::getPastNumExternalMessages</a></div><div class="ttdeci">uint32 getPastNumExternalMessages()</div><div class="ttdoc">returns the number of external messages in the previous superstep </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:267</div></div>
<div class="ttc" id="classAggregateSysMessage_html_ae919541ce5708fd7806568b53242192b"><div class="ttname"><a href="classAggregateSysMessage.html#ae919541ce5708fd7806568b53242192b">TIGLCommunicationAggregateSysMessage::setMax</a></div><div class="ttdeci">void setMax(AlgData val)</div><div class="ttdoc">set the maximum value </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:47</div></div>
<div class="ttc" id="classAggInfo_html_ab3b13064337d382555b097d41085231f"><div class="ttname"><a href="classAggInfo.html#ab3b13064337d382555b097d41085231f">TIGLContainersAggregate::incrementExternalMessagesCount</a></div><div class="ttdeci">void incrementExternalMessagesCount(uint32 currNumMessages)</div><div class="ttdoc">incrementing the number of exteranl Messages after a single node compute in a superstep ...</div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:246</div></div>
<div class="ttc" id="classAggInfo_html_aadbf3019d3dfe78da479e1e69befc203"><div class="ttname"><a href="classAggInfo.html#aadbf3019d3dfe78da479e1e69befc203">TIGLContainersAggregate::prepareAggregateSysMessage</a></div><div class="ttdeci">void prepareAggregateSysMessage(AGG_SYS_MESSAGE_TYPE *aggSysInfo)</div><div class="ttdoc">Preparing the aggregate information system message (at the end of the superstep) </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:234</div></div>
<div class="ttc" id="classAggregateSysMessage_html_a5139f89e6e3de91aadb6c1d7d00d5b85"><div class="ttname"><a href="classAggregateSysMessage.html#a5139f89e6e3de91aadb6c1d7d00d5b85">TIGLCommunicationAggregateSysMessage::setMin</a></div><div class="ttdeci">void setMin(AlgData val)</div><div class="ttdoc">set the minimum value of the algData </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:50</div></div>
<div class="ttc" id="classAggInfo_html_a71f8ccb076be729b46722dd1ab9524a8"><div class="ttname"><a href="classAggInfo.html#a71f8ccb076be729b46722dd1ab9524a8">TIGLContainersAggregate::localAggregateUpdate</a></div><div class="ttdeci">void localAggregateUpdate(VERTEX_ITERATOR vertexIt, uint32 currNumMessages)</div><div class="ttdoc">updating the aggregate information after a single node execution during a superstep ...</div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:160</div></div>
<div class="ttc" id="classAggInfo_html_a902ee9574bb43a165170566e622621ad"><div class="ttname"><a href="classAggInfo.html#a902ee9574bb43a165170566e622621ad">TIGLContainersAggregate::getNumVertices</a></div><div class="ttdeci">uint32 getNumVertices()</div><div class="ttdoc">returns the total number of vertices in the whole graph </div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:277</div></div>
<div class="ttc" id="classAggInfo_html"><div class="ttname"><a href="classAggInfo.html">TIGLContainersAggregate</a></div><div class="ttdoc">base class for aggregate information it holds important aggregate information and methods for updatin...</div><div class="ttdef"><b>Definition:</b> PregelAggregate.hpp:80</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 3 2014 16:46:36 for TIPregelGraphLibrary by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
